VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmZipArchive 
   Caption         =   "ZipArch"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cdbFiles 
      Left            =   240
      Top             =   2580
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   420
      Width           =   795
   End
   Begin VB.TextBox txtPath 
      Height          =   315
      Left            =   1080
      TabIndex        =   2
      Top             =   420
      Width           =   3195
   End
   Begin VB.CommandButton cmdUnZip 
      Caption         =   "UnZip"
      Height          =   375
      Left            =   2460
      TabIndex        =   1
      Top             =   960
      Width           =   1155
   End
   Begin VB.TextBox txtStatus 
      Height          =   285
      Left            =   1740
      TabIndex        =   0
      Text            =   "Ready"
      Top             =   2400
      Width           =   1695
   End
End
Attribute VB_Name = "frmZipArchive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdBrowse_Click()
    
    On Error GoTo ErrOut
    cdbFiles.CancelError = True
    cdbFiles.FileName = cdlOFNHideReadOnly
    cdbFiles.Filter = "All Files (*.*)|*.*"
    cdbFiles.FilterIndex = 1
    cdbFiles.InitDir = App.Path
    cdbFiles.ShowOpen
    Me.txtPath.Text = GetPath(cdbFiles.FileName)
    
    On Error GoTo 0
    Exit Sub
ErrOut:

End Sub

Private Function GetPath(ByVal FileSpec As String) As String
Dim sRevName As String
Dim sPathName As String

If Len(FileSpec) Then
    sRevName = StrReverse(FileSpec)
    sPathName = StrReverse(Right(sRevName, Len(sRevName) - InStr(sRevName, "\")))
    If Right(sPathName, 1) = ":" Then
        sPathName = sPathName & "\"
    End If
    GetPath = sPathName
End If
    
End Function
Private Sub cmdUnZip_Click()
    Me.MousePointer = vbHourglass
    Me.txtStatus.Text = "Working ..."
    Call ZipDir(Me.txtPath.Text)
    Me.txtStatus.Text = "Done"
    Me.MousePointer = vbNormal
End Sub

Private Sub ZipDir(dirname)
    Dim zfile As String
    Dim i As Integer
    Dim j As Integer
    Dim NewDir As String
    Dim okay As Integer
    Dim aDirName(1 To 300) As String
    Dim strBatFile As String
    Dim strFlgFile As String
    Dim tmpDir As String
    Dim hOutFile As Integer
    Dim strBat As String
    
    tmpDir = Environ("TMP")
    If tmpDir = "" Then tmpDir = Environ("TEMP")
    If tmpDir = "" Then tmpDir = App.Path
    
    
    'Set up FTP command files
    strBatFile = tmpDir & "\Unzip.bat"
    strFlgFile = tmpDir & "\Finish.flg"
    
    
    zfile = Dir(dirname & "\*.zip", vbNormal)
    i = 0
    
    Do While zfile <> ""
        DoEvents
        If zfile <> "." And zfile <> ".." Then
            Debug.Print zfile
            i = i + 1
            
            Do While True
                'Make sure these files are gone before resuming
                On Error Resume Next
                If Dir(strBatFile) <> "" Then Kill (strBatFile)
                If Dir(strFlgFile) <> "" Then Kill (strFlgFile)
                If Err.Number = 0 Then Exit Do
            Loop
            
            NewDir = Left(zfile, Len(zfile) - 4)
            aDirName(i) = dirname & "\" & NewDir
            
            'Create the bat file
            strBat = "md " & dirname & "\" & NewDir & vbCrLf & _
                     "move " & dirname & "\" & zfile & " " & dirname & "\" & NewDir & "\" & zfile & vbCrLf & _
                     "cd " & dirname & "\" & NewDir & vbCrLf & _
                     App.Path & "\pkunzip -o " & dirname & "\" & NewDir & "\" & zfile & vbCrLf & _
                     "del " & zfile & vbCrLf & _
                     "cd " & dirname & vbCrLf & _
                     "echo Finished > " & strFlgFile
            
            hOutFile = FreeFile
            Open strBatFile For Output As hOutFile
            Print #hOutFile, strBat
            Close hOutFile
            
            'Run the bat file
            okay = Shell(strBatFile, vbNormalFocus)
            
            'Wait for it to finish
            Do
                DoEvents
            Loop Until Dir(strFlgFile) <> ""
            
            zfile = Dir(dirname & "\*.zip", vbHidden)
        End If
    Loop
    
    For j = 1 To i
        Call ZipDir(aDirName(j))
    Next
    
End Sub

Private Sub Form_Load()
    Me.txtPath.Text = App.Path
End Sub
